{
open Lexing
open Coll_parser

let ident_or_keyword = function
  | "PROBLEM" -> PROBLEM
  | "VAR" -> VAR
  | "SIG" -> SIG
  | "RULES" -> RULES
  | "COMMENT" -> COMMENT
  | s -> IDENT s

exception Lexing_error of string

}

let letter = 
  ['a'-'z' 'A'-'Z' '0'-'9' '\''
   '#' '+' '-' '*' '/' '.' '\\' ':' ';' '=' '<' '>' '_' '@' '`' '$'
   '{' '}' '[' ']' '|' '~' '?' '&' '"' '!' '%']

rule token = parse
  | [' ' '\r' '\t'] {  token lexbuf }
  | '\n'   { new_line lexbuf; token lexbuf }
  | "->"   { ARROW }
  | "("    { LPAREN }
  | ")"    { RPAREN }
  | ","    { COMMA }
  | letter+ as s { ident_or_keyword s }
  | _      { OTHER }
  | eof    { EOF }
